Index: /main/trunk/greenstone3/src/java/org/greenstone/gsdl3/Library2.java
===================================================================
--- /main/trunk/greenstone3/src/java/org/greenstone/gsdl3/Library2.java	(revision 24992)
+++ /main/trunk/greenstone3/src/java/org/greenstone/gsdl3/Library2.java	(revision 24993)
@@ -132,5 +132,5 @@
 
 		Element xml_message = this.doc.createElement(GSXML.MESSAGE_ELEM);
-		Element xml_request = GSXML.createBasicRequest(this.doc, GSXML.REQUEST_TYPE_PAGE, "", "", "");
+		Element xml_request = GSXML.createBasicRequest(this.doc, GSXML.REQUEST_TYPE_PAGE, "", new UserContext());
 		xml_message.appendChild(xml_request);
 		Element xml_param_list = this.doc.createElement(GSXML.PARAM_ELEM + GSXML.LIST_MODIFIER);
Index: /main/trunk/greenstone3/src/java/org/greenstone/gsdl3/LibraryServlet.java
===================================================================
--- /main/trunk/greenstone3/src/java/org/greenstone/gsdl3/LibraryServlet.java	(revision 24992)
+++ /main/trunk/greenstone3/src/java/org/greenstone/gsdl3/LibraryServlet.java	(revision 24993)
@@ -544,4 +544,7 @@
 			}
 		}
+		UserContext userContext = new UserContext();
+		userContext.setLanguage(lang);
+		userContext.setUserID(uid);
 
 		// set the lang in the session
@@ -582,5 +585,5 @@
 		// the request to the receptionist
 		Element xml_message = this.doc.createElement(GSXML.MESSAGE_ELEM);
-		Element xml_request = GSXML.createBasicRequest(this.doc, GSXML.REQUEST_TYPE_PAGE, "", lang, uid);
+		Element xml_request = GSXML.createBasicRequest(this.doc, GSXML.REQUEST_TYPE_PAGE, "", userContext);
 		xml_request.setAttribute(GSXML.OUTPUT_ATT, output);
 
Index: /main/trunk/greenstone3/src/java/org/greenstone/gsdl3/action/Action.java
===================================================================
--- /main/trunk/greenstone3/src/java/org/greenstone/gsdl3/action/Action.java	(revision 24992)
+++ /main/trunk/greenstone3/src/java/org/greenstone/gsdl3/action/Action.java	(revision 24993)
@@ -232,8 +232,8 @@
 	 *            the current user id
 	 */
-	protected void addSiteMetadata(Element element, String lang, String uid)
+	protected void addSiteMetadata(Element element, UserContext userContext)
 	{
 		//ADD SITE METADATA
-		Element metadata_request = GSXML.createBasicRequest(this.doc, GSXML.REQUEST_TYPE_DESCRIBE, "", lang, uid);
+		Element metadata_request = GSXML.createBasicRequest(this.doc, GSXML.REQUEST_TYPE_DESCRIBE, "", userContext);
 		//create a hashmap of params
 		HashMap subset_params = new HashMap(1);
Index: /main/trunk/greenstone3/src/java/org/greenstone/gsdl3/action/AppletAction.java
===================================================================
--- /main/trunk/greenstone3/src/java/org/greenstone/gsdl3/action/AppletAction.java	(revision 24992)
+++ /main/trunk/greenstone3/src/java/org/greenstone/gsdl3/action/AppletAction.java	(revision 24993)
@@ -45,6 +45,5 @@
 		boolean coll_specified = true;
 		String service_name = (String) params.get(GSParams.SERVICE);
-		String lang = request.getAttribute(GSXML.LANG_ATT);
-		String uid = request.getAttribute(GSXML.USER_ID_ATT);
+		UserContext userContext = new UserContext(request);
 		String to = null;
 		if (collection == null || collection.equals(""))
@@ -63,5 +62,5 @@
 
 			Element mr_message = this.doc.createElement(GSXML.MESSAGE_ELEM);
-			Element mr_request = GSXML.createBasicRequest(this.doc, GSXML.REQUEST_TYPE_PROCESS, to, lang, uid);
+			Element mr_request = GSXML.createBasicRequest(this.doc, GSXML.REQUEST_TYPE_PROCESS, to, userContext);
 			mr_message.appendChild(mr_request);
 			// just append all the params for now - should filter out unneeded ones
@@ -81,5 +80,5 @@
 
 		Element mr_message = this.doc.createElement(GSXML.MESSAGE_ELEM);
-		Element applet_request = GSXML.createBasicRequest(this.doc, GSXML.REQUEST_TYPE_DESCRIBE, to, lang, uid);
+		Element applet_request = GSXML.createBasicRequest(this.doc, GSXML.REQUEST_TYPE_DESCRIBE, to, userContext);
 		mr_message.appendChild(applet_request);
 
Index: /main/trunk/greenstone3/src/java/org/greenstone/gsdl3/action/BrowseAction.java
===================================================================
--- /main/trunk/greenstone3/src/java/org/greenstone/gsdl3/action/BrowseAction.java	(revision 24992)
+++ /main/trunk/greenstone3/src/java/org/greenstone/gsdl3/action/BrowseAction.java	(revision 24993)
@@ -64,6 +64,5 @@
 	}
 
-	String lang = request.getAttribute(GSXML.LANG_ATT);
-	String uid = request.getAttribute(GSXML.USER_ID_ATT);	
+	UserContext userContext = new UserContext(request);	
 	String to = GSPath.appendLink(collection, service_name);
 	
@@ -73,9 +72,9 @@
 	
 	Element info_message = this.doc.createElement(GSXML.MESSAGE_ELEM);
-	Element info_request = GSXML.createBasicRequest(this.doc, GSXML.REQUEST_TYPE_DESCRIBE, to, lang, uid); 
+	Element info_request = GSXML.createBasicRequest(this.doc, GSXML.REQUEST_TYPE_DESCRIBE, to, userContext); 
 	info_message.appendChild(info_request);
 	
 	// also get the format stuff now if there is some
-	Element format_request = GSXML.createBasicRequest(this.doc, GSXML.REQUEST_TYPE_FORMAT, to, lang, uid);
+	Element format_request = GSXML.createBasicRequest(this.doc, GSXML.REQUEST_TYPE_FORMAT, to, userContext);
 	info_message.appendChild(format_request);
 	// process the requests
@@ -92,5 +91,5 @@
 	
 	//append site metadata
-	addSiteMetadata(page_response, lang, uid);
+	addSiteMetadata(page_response, userContext);
 
 	// if rt=d, then we are just displaying the service
@@ -135,5 +134,5 @@
 	// get the browse structure for the selected node
 	Element classify_message = this.doc.createElement(GSXML.MESSAGE_ELEM);
-	Element classify_request = GSXML.createBasicRequest(this.doc, GSXML.REQUEST_TYPE_PROCESS, to, lang, uid);
+	Element classify_request = GSXML.createBasicRequest(this.doc, GSXML.REQUEST_TYPE_PROCESS, to, userContext);
 	classify_message.appendChild(classify_request);
 	    
@@ -200,5 +199,5 @@
 	if (cl_nodes.getLength() > 0) {
 	    did_classifier = true;
-	    Element cl_meta_request = GSXML.createBasicRequest(this.doc, GSXML.REQUEST_TYPE_PROCESS, to+"MetadataRetrieve", lang, uid);
+	    Element cl_meta_request = GSXML.createBasicRequest(this.doc, GSXML.REQUEST_TYPE_PROCESS, to+"MetadataRetrieve", userContext);
 	    metadata_message.appendChild(cl_meta_request);
 	    
@@ -237,5 +236,5 @@
 	if (doc_nodes.getLength() > 0) {
 	    did_documents = true;
-	    Element doc_meta_request = GSXML.createBasicRequest(this.doc, GSXML.REQUEST_TYPE_PROCESS, GSPath.appendLink(collection, "DocumentMetadataRetrieve"), lang, uid);
+	    Element doc_meta_request = GSXML.createBasicRequest(this.doc, GSXML.REQUEST_TYPE_PROCESS, GSPath.appendLink(collection, "DocumentMetadataRetrieve"), userContext);
 	    metadata_message.appendChild(doc_meta_request);
 	    
Index: /main/trunk/greenstone3/src/java/org/greenstone/gsdl3/action/DocumentAction.java
===================================================================
--- /main/trunk/greenstone3/src/java/org/greenstone/gsdl3/action/DocumentAction.java	(revision 24992)
+++ /main/trunk/greenstone3/src/java/org/greenstone/gsdl3/action/DocumentAction.java	(revision 24993)
@@ -97,6 +97,5 @@
 		has_rl = (String) params.get("rl");//for an external link : get the rl value if it is existing in the params list
 		String collection = (String) params.get(GSParams.COLLECTION);
-		String lang = request.getAttribute(GSXML.LANG_ATT);
-		String uid = request.getAttribute(GSXML.USER_ID_ATT);
+		UserContext userContext = new UserContext(request);
 		String document_name = (String) params.get(GSParams.DOCUMENT);
 		if ((document_name == null || document_name.equals("")) && (has_href == null || has_href.equals("")))
@@ -147,8 +146,8 @@
 
 		//append site metadata
-		addSiteMetadata(page_response, lang, uid);
+		addSiteMetadata(page_response, userContext);
 
 		// get the additional data needed for the page
-		getBackgroundData(page_response, collection, lang, uid);
+		getBackgroundData(page_response, collection, userContext);
 		Element format_elem = (Element) GSXML.getChildByTagName(page_response, GSXML.FORMAT_ELEM);
 
@@ -263,5 +262,5 @@
 			Element ds_message = this.doc.createElement(GSXML.MESSAGE_ELEM);
 			String to = GSPath.appendLink(collection, "DocumentStructureRetrieve");// Hard-wired?
-			Element ds_request = GSXML.createBasicRequest(this.doc, GSXML.REQUEST_TYPE_PROCESS, to, lang, uid);
+			Element ds_request = GSXML.createBasicRequest(this.doc, GSXML.REQUEST_TYPE_PROCESS, to, userContext);
 			ds_message.appendChild(ds_request);
 			ds_request.appendChild(ds_param_list);
@@ -339,5 +338,5 @@
 		Element dm_message = this.doc.createElement(GSXML.MESSAGE_ELEM);
 		String to = GSPath.appendLink(collection, "DocumentMetadataRetrieve"); // Hard-wired?
-		Element dm_request = GSXML.createBasicRequest(this.doc, GSXML.REQUEST_TYPE_PROCESS, to, lang, uid);
+		Element dm_request = GSXML.createBasicRequest(this.doc, GSXML.REQUEST_TYPE_PROCESS, to, userContext);
 		dm_message.appendChild(dm_request);
 		// Create a parameter list to specify the required metadata information
@@ -378,5 +377,5 @@
 		// we also want a metadata request to the top level document to get
 		// assocfilepath - this could be cached too
-		Element doc_meta_request = GSXML.createBasicRequest(this.doc, GSXML.REQUEST_TYPE_PROCESS, to, lang, uid);
+		Element doc_meta_request = GSXML.createBasicRequest(this.doc, GSXML.REQUEST_TYPE_PROCESS, to, userContext);
 		dm_message.appendChild(doc_meta_request);
 		Element doc_meta_param_list = this.doc.createElement(GSXML.PARAM_ELEM + GSXML.LIST_MODIFIER);
@@ -432,5 +431,5 @@
 		Element dc_message = this.doc.createElement(GSXML.MESSAGE_ELEM);
 		to = GSPath.appendLink(collection, "DocumentContentRetrieve"); // Hard-wired?
-		Element dc_request = GSXML.createBasicRequest(this.doc, GSXML.REQUEST_TYPE_PROCESS, to, lang, uid);
+		Element dc_request = GSXML.createBasicRequest(this.doc, GSXML.REQUEST_TYPE_PROCESS, to, userContext);
 		dc_message.appendChild(dc_request);
 
@@ -517,5 +516,5 @@
 					// send a message to the service
 					Element enrich_message = this.doc.createElement(GSXML.MESSAGE_ELEM);
-					Element enrich_request = GSXML.createBasicRequest(this.doc, GSXML.REQUEST_TYPE_PROCESS, enrich_service, lang, uid);
+					Element enrich_request = GSXML.createBasicRequest(this.doc, GSXML.REQUEST_TYPE_PROCESS, enrich_service, userContext);
 					enrich_message.appendChild(enrich_request);
 					// check for parameters
@@ -610,5 +609,5 @@
 	 * whatever the query is - should be cached
 	 */
-	protected boolean getBackgroundData(Element page_response, String collection, String lang, String uid)
+	protected boolean getBackgroundData(Element page_response, String collection, UserContext userContext)
 	{
 
@@ -619,5 +618,5 @@
 		String path = GSPath.appendLink(collection, "DocumentContentRetrieve");
 		// the format request - ignore for now, where does this request go to??
-		Element format_request = GSXML.createBasicRequest(this.doc, GSXML.REQUEST_TYPE_FORMAT, path, lang, uid);
+		Element format_request = GSXML.createBasicRequest(this.doc, GSXML.REQUEST_TYPE_FORMAT, path, userContext);
 		info_message.appendChild(format_request);
 
@@ -626,5 +625,5 @@
 		if (provide_annotations)
 		{
-			Element enrich_services_request = GSXML.createBasicRequest(this.doc, GSXML.REQUEST_TYPE_DESCRIBE, "", lang, uid);
+			Element enrich_services_request = GSXML.createBasicRequest(this.doc, GSXML.REQUEST_TYPE_DESCRIBE, "", userContext);
 			enrich_services_request.setAttribute(GSXML.INFO_ATT, "serviceList");
 			info_message.appendChild(enrich_services_request);
@@ -659,5 +658,5 @@
 				if (((Element) e_services.item(j)).getAttribute(GSXML.TYPE_ATT).equals("enrich"))
 				{
-					Element s = GSXML.createBasicRequest(this.doc, GSXML.REQUEST_TYPE_DESCRIBE, ((Element) e_services.item(j)).getAttribute(GSXML.NAME_ATT), lang, uid);
+					Element s = GSXML.createBasicRequest(this.doc, GSXML.REQUEST_TYPE_DESCRIBE, ((Element) e_services.item(j)).getAttribute(GSXML.NAME_ATT), userContext);
 					enrich_message.appendChild(s);
 					service_found = true;
@@ -711,10 +710,9 @@
 		}
 		String collection = (String) params.get(GSParams.COLLECTION);
-		String lang = request.getAttribute(GSXML.LANG_ATT);
-		String uid = request.getAttribute(GSXML.USER_ID_ATT);
+		UserContext userContext = new UserContext(request);
 		String to = GSPath.appendLink(collection, service_name);
 
 		Element mr_query_message = this.doc.createElement(GSXML.MESSAGE_ELEM);
-		Element mr_query_request = GSXML.createBasicRequest(this.doc, GSXML.REQUEST_TYPE_PROCESS, to, lang, uid);
+		Element mr_query_request = GSXML.createBasicRequest(this.doc, GSXML.REQUEST_TYPE_PROCESS, to, userContext);
 		mr_query_message.appendChild(mr_query_request);
 
@@ -899,5 +897,5 @@
 		{
 			//We don't want to find words inside HTML tags
-			if(content_characters[i] == '<')
+			if (content_characters[i] == '<')
 			{
 				inTag = true;
@@ -912,7 +910,7 @@
 				continue;
 			}
-			
+
 			boolean is_character_letter_or_digit = Character.isLetterOrDigit(content_characters[i]);
-			
+
 			// Has a word just started?
 			if (in_word == false && is_character_letter_or_digit == true)
Index: /main/trunk/greenstone3/src/java/org/greenstone/gsdl3/action/FormatAction.java
===================================================================
--- /main/trunk/greenstone3/src/java/org/greenstone/gsdl3/action/FormatAction.java	(revision 24992)
+++ /main/trunk/greenstone3/src/java/org/greenstone/gsdl3/action/FormatAction.java	(revision 24993)
@@ -12,5 +12,4 @@
 // other java stuff
 import java.io.File;
-import java.util.HashMap;
 import java.util.*;
 import java.io.StringReader;
@@ -46,6 +45,5 @@
 	
     	String subaction = request.getAttribute(GSXML.SUBACTION_ATT);
-	    String lang = request.getAttribute(GSXML.LANG_ATT);
-    	String uid = request.getAttribute(GSXML.USER_ID_ATT);
+    	UserContext userContext = new UserContext(request);
 	    // get the param list
     	Element cgi_param_list = (Element)GSXML.getChildByTagName(request, GSXML.PARAM_ELEM+GSXML.LIST_MODIFIER);
@@ -64,5 +62,5 @@
 
         Element mr_request_message = this.doc.createElement(GSXML.MESSAGE_ELEM);
-        Element mr_request = GSXML.createBasicRequest(this.doc, GSXML.REQUEST_TYPE_FORMAT_STRING, to, lang, uid);
+        Element mr_request = GSXML.createBasicRequest(this.doc, GSXML.REQUEST_TYPE_FORMAT_STRING, to, userContext);
 
         mr_request.setAttribute("service", service);
Index: /main/trunk/greenstone3/src/java/org/greenstone/gsdl3/action/GS2BrowseAction.java
===================================================================
--- /main/trunk/greenstone3/src/java/org/greenstone/gsdl3/action/GS2BrowseAction.java	(revision 24992)
+++ /main/trunk/greenstone3/src/java/org/greenstone/gsdl3/action/GS2BrowseAction.java	(revision 24993)
@@ -58,6 +58,5 @@
 		}
 
-		String lang = request.getAttribute(GSXML.LANG_ATT);
-		String uid = request.getAttribute(GSXML.USER_ID_ATT);
+		UserContext userContext = new UserContext(request);
 		String to = GSPath.appendLink(collection, service_name);
 
@@ -67,9 +66,9 @@
 
 		Element info_message = this.doc.createElement(GSXML.MESSAGE_ELEM);
-		Element info_request = GSXML.createBasicRequest(this.doc, GSXML.REQUEST_TYPE_DESCRIBE, to, lang, uid);
+		Element info_request = GSXML.createBasicRequest(this.doc, GSXML.REQUEST_TYPE_DESCRIBE, to, userContext);
 		info_message.appendChild(info_request);
 
 		// also get the format stuff now if there is some
-		Element format_request = GSXML.createBasicRequest(this.doc, GSXML.REQUEST_TYPE_FORMAT, to, lang, uid);
+		Element format_request = GSXML.createBasicRequest(this.doc, GSXML.REQUEST_TYPE_FORMAT, to, userContext);
 		info_message.appendChild(format_request);
 		// process the requests
@@ -86,5 +85,5 @@
 
 		//append site metadata
-		addSiteMetadata(page_response, lang, uid);
+		addSiteMetadata(page_response, userContext);
 
 		// if rt=d, then we are just displaying the service
@@ -154,5 +153,5 @@
 		// get the browse structure for the selected node
 		Element classify_message = this.doc.createElement(GSXML.MESSAGE_ELEM);
-		Element classify_request = GSXML.createBasicRequest(this.doc, GSXML.REQUEST_TYPE_PROCESS, to, lang, uid);
+		Element classify_request = GSXML.createBasicRequest(this.doc, GSXML.REQUEST_TYPE_PROCESS, to, userContext);
 		classify_message.appendChild(classify_request);
 
@@ -252,5 +251,5 @@
 		{
 			did_classifier = true;
-			Element cl_meta_request = GSXML.createBasicRequest(this.doc, GSXML.REQUEST_TYPE_PROCESS, to + "MetadataRetrieve", lang, uid);
+			Element cl_meta_request = GSXML.createBasicRequest(this.doc, GSXML.REQUEST_TYPE_PROCESS, to + "MetadataRetrieve", userContext);
 			metadata_message.appendChild(cl_meta_request);
 
@@ -281,5 +280,5 @@
 		{
 			did_documents = true;
-			Element doc_meta_request = GSXML.createBasicRequest(this.doc, GSXML.REQUEST_TYPE_PROCESS, GSPath.appendLink(collection, "DocumentMetadataRetrieve"), lang, uid);
+			Element doc_meta_request = GSXML.createBasicRequest(this.doc, GSXML.REQUEST_TYPE_PROCESS, GSPath.appendLink(collection, "DocumentMetadataRetrieve"), userContext);
 			metadata_message.appendChild(doc_meta_request);
 
Index: /main/trunk/greenstone3/src/java/org/greenstone/gsdl3/action/GeneralAction.java
===================================================================
--- /main/trunk/greenstone3/src/java/org/greenstone/gsdl3/action/GeneralAction.java	(revision 24992)
+++ /main/trunk/greenstone3/src/java/org/greenstone/gsdl3/action/GeneralAction.java	(revision 24993)
@@ -26,6 +26,5 @@
 		logger.debug(" request=" + this.converter.getString(request));
 
-		String lang = request.getAttribute(GSXML.LANG_ATT);
-		String uid = request.getAttribute(GSXML.USER_ID_ATT);
+		UserContext userContext = new UserContext(request);
 
 		// get the param list
@@ -66,5 +65,5 @@
 
 			Element mr_query_message = this.doc.createElement(GSXML.MESSAGE_ELEM);
-			Element mr_query_request = GSXML.createBasicRequest(this.doc, GSXML.REQUEST_TYPE_PROCESS, to, lang, uid);
+			Element mr_query_request = GSXML.createBasicRequest(this.doc, GSXML.REQUEST_TYPE_PROCESS, to, userContext);
 			
 			if(request_type.equals("s"))
@@ -91,5 +90,5 @@
 			{
 				// just send the reponse as is
-				addSiteMetadata(result_response, lang, uid);
+				addSiteMetadata(result_response, userContext);
 				return result_response;
 			}
@@ -105,5 +104,5 @@
 		// request the service info for the selected service - should be cached
 		Element mr_info_message = this.doc.createElement(GSXML.MESSAGE_ELEM);
-		Element mr_info_request = GSXML.createBasicRequest(this.doc, GSXML.REQUEST_TYPE_DESCRIBE, to, lang, uid);
+		Element mr_info_request = GSXML.createBasicRequest(this.doc, GSXML.REQUEST_TYPE_DESCRIBE, to, userContext);
 		mr_info_message.appendChild(mr_info_request);
 		Element mr_info_response = (Element) this.mr.process(mr_info_message);
@@ -118,5 +117,5 @@
 		}
 
-		addSiteMetadata(page_response, lang, uid);
+		addSiteMetadata(page_response, userContext);
 		
 		return result;
Index: /main/trunk/greenstone3/src/java/org/greenstone/gsdl3/action/NoCollQueryAction.java
===================================================================
--- /main/trunk/greenstone3/src/java/org/greenstone/gsdl3/action/NoCollQueryAction.java	(revision 24992)
+++ /main/trunk/greenstone3/src/java/org/greenstone/gsdl3/action/NoCollQueryAction.java	(revision 24993)
@@ -65,6 +65,5 @@
 
 		String request_type = (String) params.get(GSParams.REQUEST_TYPE);
-		String lang = request.getAttribute(GSXML.LANG_ATT);
-		String uid = request.getAttribute(GSXML.USER_ID_ATT);
+		UserContext userContext = new UserContext(request);
 		if (request_type.equals("d"))
 		{
@@ -72,5 +71,5 @@
 			// the only info we need to return is the collection list cos the xslt does teh rest
 
-			Element coll_list = getCollectionList(lang, uid);
+			Element coll_list = getCollectionList(userContext);
 			page_response.appendChild(this.doc.importNode(coll_list, true));
 			return page_response;
@@ -89,5 +88,5 @@
 		{
 			logger.error("no collections were specified!");
-			Element coll_list = getCollectionList(lang, uid);
+			Element coll_list = getCollectionList(userContext);
 			page_response.appendChild(this.doc.importNode(coll_list, true));
 			return page_response;
@@ -111,5 +110,5 @@
 		{
 			String to = GSPath.appendLink(colls[i], service_name);
-			Element mr_query_request = GSXML.createBasicRequest(this.doc, GSXML.REQUEST_TYPE_PROCESS, to, lang, uid);
+			Element mr_query_request = GSXML.createBasicRequest(this.doc, GSXML.REQUEST_TYPE_PROCESS, to, userContext);
 			mr_query_message.appendChild(mr_query_request);
 			mr_query_request.appendChild(query_param_list.cloneNode(true));
@@ -130,5 +129,5 @@
 				String coll_name = extractCollName(((Element) responses.item(j)).getAttribute(GSXML.FROM_ATT));
 				String path = GSPath.appendLink(coll_name, "DocumentMetadataRetrieve");
-				Element mr_meta_request = GSXML.createBasicRequest(this.doc, GSXML.REQUEST_TYPE_PROCESS, path, lang, uid);
+				Element mr_meta_request = GSXML.createBasicRequest(this.doc, GSXML.REQUEST_TYPE_PROCESS, path, userContext);
 				mr_meta_message.appendChild(mr_meta_request);
 				mr_meta_request.appendChild(this.doc.importNode(document_list, true));
@@ -182,10 +181,10 @@
 	}
 
-	protected Element getCollectionList(String lang, String uid)
+	protected Element getCollectionList(UserContext userContext)
 	{
 
 		// first, get the message router info
 		Element coll_list_message = this.doc.createElement(GSXML.MESSAGE_ELEM);
-		Element coll_list_request = GSXML.createBasicRequest(this.doc, GSXML.REQUEST_TYPE_DESCRIBE, "", lang, uid);
+		Element coll_list_request = GSXML.createBasicRequest(this.doc, GSXML.REQUEST_TYPE_DESCRIBE, "", userContext);
 		coll_list_message.appendChild(coll_list_request);
 		Element coll_list_response = (Element) this.mr.process(coll_list_message);
@@ -209,5 +208,5 @@
 			String name = c.getAttribute(GSXML.NAME_ATT);
 
-			Element metadata_request = GSXML.createBasicRequest(this.doc, GSXML.REQUEST_TYPE_DESCRIBE, name, lang, uid);
+			Element metadata_request = GSXML.createBasicRequest(this.doc, GSXML.REQUEST_TYPE_DESCRIBE, name, userContext);
 			metadata_request.appendChild(coll_param_list.cloneNode(true));
 			metadata_message.appendChild(metadata_request);
Index: /main/trunk/greenstone3/src/java/org/greenstone/gsdl3/action/PageAction.java
===================================================================
--- /main/trunk/greenstone3/src/java/org/greenstone/gsdl3/action/PageAction.java	(revision 24992)
+++ /main/trunk/greenstone3/src/java/org/greenstone/gsdl3/action/PageAction.java	(revision 24993)
@@ -69,9 +69,8 @@
 	{
 
-		String lang = request.getAttribute(GSXML.LANG_ATT);
-		String uid = request.getAttribute(GSXML.USER_ID_ATT);
+		UserContext userContext = new UserContext(request);
 		// first, get the message router info
 		Element info_message = this.doc.createElement(GSXML.MESSAGE_ELEM);
-		Element coll_list_request = GSXML.createBasicRequest(this.doc, GSXML.REQUEST_TYPE_DESCRIBE, "", lang, uid);
+		Element coll_list_request = GSXML.createBasicRequest(this.doc, GSXML.REQUEST_TYPE_DESCRIBE, "", userContext);
 		info_message.appendChild(coll_list_request);
 		Element info_response_message = (Element) this.mr.process(info_message);
@@ -97,5 +96,5 @@
 			if (colls.getLength() > 0)
 			{
-				sendMultipleRequests(colls, null, GSXML.REQUEST_TYPE_DESCRIBE, lang, uid);
+				sendMultipleRequests(colls, null, GSXML.REQUEST_TYPE_DESCRIBE, userContext);
 			}
 		}
@@ -108,5 +107,5 @@
 			if (services.getLength() > 0)
 			{
-				sendMultipleRequests(services, null, GSXML.REQUEST_TYPE_DESCRIBE, lang, uid);
+				sendMultipleRequests(services, null, GSXML.REQUEST_TYPE_DESCRIBE, userContext);
 			}
 		}
@@ -119,5 +118,5 @@
 			if (clusters.getLength() > 0)
 			{
-				sendMultipleRequests(clusters, null, GSXML.REQUEST_TYPE_DESCRIBE, lang, uid);
+				sendMultipleRequests(clusters, null, GSXML.REQUEST_TYPE_DESCRIBE, userContext);
 
 			}
@@ -132,6 +131,5 @@
 	{
 
-		String lang = request.getAttribute(GSXML.LANG_ATT);
-		String uid = request.getAttribute(GSXML.USER_ID_ATT);
+		UserContext userContext = new UserContext(request);
 		// extract the params from the cgi-request, 
 		Element cgi_paramList = (Element) GSXML.getChildByTagName(request, GSXML.PARAM_ELEM + GSXML.LIST_MODIFIER);
@@ -144,5 +142,5 @@
 			// return an empty response
 			Element response = this.doc.createElement(GSXML.RESPONSE_ELEM);
-			addSiteMetadata(response, lang, uid);
+			addSiteMetadata(response, userContext);
 			return response;
 		}
@@ -151,5 +149,5 @@
 		Element coll_about_message = this.doc.createElement(GSXML.MESSAGE_ELEM);
 
-		Element coll_about_request = GSXML.createBasicRequest(this.doc, GSXML.REQUEST_TYPE_DESCRIBE, coll_name, lang, uid);
+		Element coll_about_request = GSXML.createBasicRequest(this.doc, GSXML.REQUEST_TYPE_DESCRIBE, coll_name, userContext);
 		coll_about_message.appendChild(coll_about_request);
 		Element coll_about_response = (Element) this.mr.process(coll_about_message);
@@ -196,10 +194,10 @@
 		if (services.getLength() > 0)
 		{
-			sendMultipleRequests(services, coll_name, GSXML.REQUEST_TYPE_DESCRIBE, lang, uid);
+			sendMultipleRequests(services, coll_name, GSXML.REQUEST_TYPE_DESCRIBE, userContext);
 		}
 
 		Element response = (Element) GSXML.getChildByTagName(coll_about_response, GSXML.RESPONSE_ELEM);
 		//add the site metadata
-		addSiteMetadata(response, lang, uid);
+		addSiteMetadata(response, userContext);
 		return response;
 	}
@@ -213,7 +211,5 @@
 	protected Element unknownPage(Element request)
 	{
-
-		String lang = request.getAttribute(GSXML.LANG_ATT);
-		String uid = request.getAttribute(GSXML.USER_ID_ATT);
+		UserContext userContext = new UserContext(request);
 		String page_name = request.getAttribute(GSXML.SUBACTION_ATT);
 
@@ -227,5 +223,5 @@
 			// just return an empty response
 			Element response = this.doc.createElement(GSXML.RESPONSE_ELEM);
-			addSiteMetadata(response, lang, uid);
+			addSiteMetadata(response, userContext);
 			return response;
 		}
@@ -237,5 +233,5 @@
 		Element coll_about_message = this.doc.createElement(GSXML.MESSAGE_ELEM);
 
-		Element coll_about_request = GSXML.createBasicRequest(this.doc, GSXML.REQUEST_TYPE_DESCRIBE, coll_name, lang, uid);
+		Element coll_about_request = GSXML.createBasicRequest(this.doc, GSXML.REQUEST_TYPE_DESCRIBE, coll_name, userContext);
 		coll_about_message.appendChild(coll_about_request);
 
@@ -245,5 +241,5 @@
 
 		//add the site metadata
-		addSiteMetadata(response, lang, uid);
+		addSiteMetadata(response, userContext);
 
 		return response;
@@ -251,5 +247,5 @@
 	}
 
-	protected boolean sendMultipleRequests(NodeList items, String path_prefix, String request_type, String lang, String uid)
+	protected boolean sendMultipleRequests(NodeList items, String path_prefix, String request_type, UserContext userContext)
 	{
 
@@ -264,5 +260,5 @@
 				path = GSPath.appendLink(path_prefix, path);
 			}
-			Element request = GSXML.createBasicRequest(this.doc, request_type, path, lang, uid);
+			Element request = GSXML.createBasicRequest(this.doc, request_type, path, userContext);
 			message.appendChild(request);
 		}
Index: /main/trunk/greenstone3/src/java/org/greenstone/gsdl3/action/ProcessAction.java
===================================================================
--- /main/trunk/greenstone3/src/java/org/greenstone/gsdl3/action/ProcessAction.java	(revision 24992)
+++ /main/trunk/greenstone3/src/java/org/greenstone/gsdl3/action/ProcessAction.java	(revision 24993)
@@ -43,6 +43,5 @@
 		}
 		String request_type = (String) params.get(GSParams.REQUEST_TYPE);
-		String lang = request.getAttribute(GSXML.LANG_ATT);
-		String uid = request.getAttribute(GSXML.USER_ID_ATT);
+		UserContext userContext = new UserContext(request);
 		// what is carried out depends on the request_type
 		// if rt=d, then a describe request is done,
@@ -94,5 +93,5 @@
 
 			}
-			Element mr_query_request = GSXML.createBasicRequest(this.doc, request_type_att, to, lang, uid);
+			Element mr_query_request = GSXML.createBasicRequest(this.doc, request_type_att, to, userContext);
 			if (param_list != null)
 			{
@@ -119,5 +118,5 @@
 		// request the service info for the selected service - should be cached
 		Element mr_info_message = this.doc.createElement(GSXML.MESSAGE_ELEM);
-		Element mr_info_request = GSXML.createBasicRequest(this.doc, GSXML.REQUEST_TYPE_DESCRIBE, to, lang, uid);
+		Element mr_info_request = GSXML.createBasicRequest(this.doc, GSXML.REQUEST_TYPE_DESCRIBE, to, userContext);
 		mr_info_message.appendChild(mr_info_request);
 		Element mr_info_response = (Element) this.mr.process(mr_info_message);
